<template>
<f7-app :params="f7params" >
	<!-- Status bar overlay for fullscreen mode-->
	<f7-statusbar></f7-statusbar>

	<!-- Views/Tabs container -->
	<f7-views tabs class="safe-areas tabs-animated-wrap">
		<!-- Tabbar for switching views-tabs -->
		<f7-toolbar tabbar labels bottom>

			<f7-link text="Home" tab-link="#view-home" icon-size="24" tab-link-active icon-ios="f7:home" icon-aurora="f7:home" icon-md="f7:home"></f7-link>

			<f7-link text="Chat" tab-link="#view-chat" icon-size="30" icon-ios="f7:chat" icon-aurora="f7:chat" icon-md="f7:chat"></f7-link>

			<f7-link tab-link="#view-panic" icon-ios="material:touch_app" icon-aurora="material:touch_app" icon-md="material:touch_app"></f7-link>

			<f7-link text="Iklan Baris" tab-link="#view-marketplace" icon-ios="f7:search" icon-aurora="f7:search" icon-md="f7:search"></f7-link>

			<f7-link tab-link="#view-account" v-if="user">
				<img v-if="user.profile.media != null" :src="user.profile.media.url.small" width="28" class="img-circle">
				<div v-else :data-initial-small="user.profile.initial"></div>
				<span class="tabbar-label">Akun</span>
			</f7-link>

		</f7-toolbar>

		<!-- Your main view/tab, should have "view-main" class. It also has "tab-active" class -->
		<f7-view id="view-home" main tab tab-active url="/" class="main-menu"></f7-view>

		<!-- Order View -->
		<f7-view id="view-chat" name="chat" tab url="/chat/" class="main-menu"></f7-view>

		<!-- Panic View -->
		<f7-view id="view-panic" name="panic" tab url="/panic/" class="main-menu"></f7-view>

		<!-- Shopping Cart View -->
		<f7-view id="view-marketplace" name="marketplace" tab url="/marketplace/" class="main-menu"></f7-view>

		<!-- Account View -->
		<f7-view id="view-account" name="account" tab url="/account/" class="main-menu"></f7-view>

		<div class="sheet-modal panic-swipe-to-step" style="height:auto; --f7-sheet-bg-color: #fff;">
			<div class="sheet-modal-inner">
				<div class="sheet-modal-swipe-step">
					<f7-block-title class="display-block margin-top text-align-center font-bold" style="font-size: 22px;margin-bottom: 20px;">{{ panic.title }}</f7-block-title>
					
					<div class="padding-horizontal padding-bottom">
						<f7-row>
							<f7-col width="70">
								<f7-button id="panic-close" large fill class="text-uppercase bg-lightblue">Tutup Layar</f7-button>
							</f7-col>
							<f7-col width="30">
								<f7-button id="sound-off" large fill class="text-uppercase bg-lightblue">
									<f7-icon material="volume_off"></f7-icon>
								</f7-button>
							</f7-col>
						</f7-row>
						<div class="margin-top text-align-center">Geser layar ke atas untuk melihat lokasi</div>
					</div>
				</div>
				<div class="map-wrapper">
					<GmapMap 
						id="panic-map"
						ref="mapRef"
						:options="{
							zoomControl: true,
							mapTypeControl: false,
							scaleControl: false,
							streetViewControl: false,
							rotateControl: false,
							fullscreenControl: true,
							disableDefaultUi: false,
							scrollwheel: false
						}"
						:zoom="map.zoom"
						:center="map.center"
						:draggable="true">
						<GmapMarker :position="map.center"></GmapMarker>
					</GmapMap>
				</div>
			</div>
		</div>

	</f7-views>
</f7-app>
</template>
<script>
	import Vue from 'vue';
	import { mapGetters } from 'vuex';
	import cordovaApp from '../js/cordova-app.js';
	import routes from '../js/routes.js';
	import store from '../js/store/index.js';
	import welcomescreen from 'f7-welcomescreen';
	import { gmapApi } from 'vue2-google-maps';
	import Pusher from 'pusher-js';
	import { setTimeout } from 'timers';

	export default {
		data() {
			return {
				// Framework7 Parameters
				f7params: {
					id: 'id.ringsatu', // App bundle ID
					name: 'RingSatu', // App name
					theme: 'ios', // Automatic theme detection
					// App root data
					data: function () {
						return {
						};
					},

					// App routes
					routes: routes,

					// Input settings
					input: {
						scrollIntoViewOnFocus: this.$device.cordova && !this.$device.electron,
						scrollIntoViewCentered: this.$device.cordova && !this.$device.electron,
					},
					// Cordova Statusbar settings
					statusbar: {
						overlay: this.$device.cordova && this.$device.ios || 'auto',
						iosOverlaysWebView: true,
						androidOverlaysWebView: false,
					},
					
					//touch
					touch: {
						tapHold: true,
						fastClick: true,
						tapHoldDelay: 3000,
						tapHoldPreventClicks: true
					},

					//welcomescreen
					welcomescreen: {
						slides: [{
							id: 'slide0', 
							title: 'Selamat Datang', 
							picture: '<div class="tour-img" style="margin-top:250px;"><img src="'+require("../assets/logo-text-only.png")+'" width="300"/></div>',
							text: 'Manajemen lingkungan tempat tinggal anda dalam satu aplikasi, secara instan dan fleksibel.'
						}, {
							id: 'slide1',
							title: 'Pemberitahuan', 
							picture: '<div class="tour-img"><img src="'+require("../assets/images/announcement.png")+'" width="220"/></div>',
							text: 'Buat pemberitahuan dan pengumuman untuk dan dari warga dalam 1 click.'
						}, {
							id: 'slide2',
							title: 'Laporan Keuangan', 
							picture: '<div class="tour-img"><img src="'+require("../assets/images/financial.png")+'" width="350"/></div>',
							text: 'Laporan arus kas keuangan perumahan secara transparan.'
						}, {
							id: 'slide3',
							title: 'Marketplace', 
							picture: '<div class="tour-img"><img src="'+require("../assets/images/economy.png")+'" width="350"/></div>',
							text: 'Kembangkan perekonomian sekitar perumahan dengan fitur jual beli.'
						}, {
							id: 'slide4',
							title: 'CCTV', 
							picture: '<div class="tour-img"><img src="'+require("../assets/images/cctv.png")+'" width="300"/></div>',
							text: 'Pantau CCTV perumahan anda secara online dari manapun dan kapanpun.'
						}, {
							id: 'slide5',
							title: 'Tombol Panik', 
							picture: '<div class="tour-img"><img src="'+require("../assets/images/security.png")+'" width="300"/></div>',
							text: 'Dapatkan pertolongan pertama bagi anda dan keluarga dengan menekan tombol panik.'
						}, {
							id: 'slide6',
							title: 'RingSatu', 
							picture: '<div class="tour-img"><img src="'+require("../assets/images/happy.png")+'" width="300"/></div>',
							text: 'Bangun lingkungan tempat tinggal anda bersama kami segera.'
						}],
						options: {
							bgcolor: '#fff',
							fontcolor: '#222',
							closeButtonText: 'MASUK',
							navigation: false,
							open: function(){
								localStorage.setItem('tour', 0);
							},
							onClosed: function(){
								localStorage.setItem('tour', 1);
							}
						}
						
					},
					methods: {
						addCurrentLocation(location){
							const self = this;
							var vuex = JSON.parse(localStorage.getItem('vuex'));

							// panic expiration time in reporter device only
							var live_mode = localStorage.getItem('live_mode');							

							if(live_mode != null && vuex && vuex.auth != null){
								let [liveId, liveExpired] = live_mode.split('|');
								let currentTimestamp = new Date().getTime() / 1000;
								let token = vuex.auth.token != null ? vuex.auth.token.access_token : null;

								if(token != null && parseInt(liveExpired) > currentTimestamp){
									location.panic = parseInt(liveId);

									Vue.http.post('http://api.ringsatu.id/v1/livelocation', location, {
										headers: {
											'X-Requested-With': 'XMLHttpRequest',
											'Content-Type': 'application/json',
											'Authorization': 'Bearer ' + token
										}
									});

								}else{
									localStorage.removeItem('live_mode');
									self.dialog.alert('Sesi pengiriman lokasi panik anda telah habis. Silahkan tekan kembali tombol panik untuk mengirim ulang sinyal tombol panik.', 'RingSatu');
								}
								
							}

							localStorage.setItem('currentLocation', JSON.stringify(location));

						},
						takePicture: function (sourceType) {
							return new Promise(function (resolve, reject) {
								var options = {
									quality: 85,
									destinationType: Camera.DestinationType.FILE_URI,
									sourceType: sourceType,
									saveToPhotoAlbum: false,
									mediaType: Camera.MediaType.PICTURE,
									allowEdit: false,
									encodingType: Camera.EncodingType.JPEG,
									targetWidth: 1024,
									targetHeight: 1024,
									correctOrientation: true
								};
			
								navigator.camera.getPicture(function (imagePath) {
									imagePath = 'file://' + imagePath;
									const opt = { quality: 100, targetWidth: -1, targetHeight: -1 };

									plugins.crop.promise(imagePath, opt).then( (newPath) => {
										resolve(newPath);
									}).catch( (err) => {
										reject(err);
									});
								}, function (e) {
									reject(e);
								}, options);
							});
						},
						storePicture: function (opts) {
							var required = function () {
								throw new Error('Required parameter not supplied');
							};

							var url = opts.url === undefined ? required() : opts.url;
							var key = opts.key === undefined ? 'media' : opts.key;
							var imagePath = typeof opts.imagePath !== 'string' || opts.imagePath === undefined ? required() : opts.imagePath;
							var params = opts.params === undefined ? {} : opts.params;
							var method = typeof opts.method !== 'string' || opts.method === undefined ? 'POST' : opts.method;
						
							params = params || {};

							var vuex = JSON.parse(localStorage.getItem('vuex'));
							return new Promise(function (resolve, reject) {
								var op = new FileUploadOptions();
								op.fileKey = key;
								op.mimeType = "image/jpeg";
								op.chunkedMode = false;
								op.headers = {
									Authorization: 'Bearer ' + vuex.auth.token.access_token
								};
								op.httpMethod = method;
								op.params = params;
						
								window.FilePath.resolveNativePath(imagePath, function (oriEntry) {
									window.resolveLocalFileSystemURL(oriEntry, function (fileEntry) {
										var fileName = fileEntry.nativeURL;
										op.fileName = fileName.substr(fileName.lastIndexOf('/') + 1);
						
										var ft = new FileTransfer();
										return ft.upload(fileEntry.nativeURL, Vue.http.defaults.baseURL + url, function (r) {
											resolve(r);
										}, function (e) {
											reject(e);
										}, op, true);
									}, function (e) {
										reject(e);
									});
								}, function (e) {
									reject(e);
								});
							});
						},
					}
				},
				map: {
					zoom: 18,
					center: {
						lat: -2.9760735,
						lng: 104.77543070000002 
					}
				},
				panic: {
					id: null,
					title: '',
					reporter: '',
					address: '',
					phone: '',
					latitude: null,
					longitude: null
				}
			}
		},
		computed: {
			...mapGetters('auth', ['user'])
		},
		methods: {
			google: gmapApi,			
		},
		mounted() {
			this.$f7ready((f7) => {

				let self = this;

				// Init cordova APIs (see cordova-app.js)
				if (f7.device.cordova) {
					cordovaApp.init(f7);
				}

				// Call F7 APIs here
				if(localStorage.getItem('tour') == 1){
					f7.welcomescreen.close();
				}

				//pusher API
				Pusher.logToConsole = false;

				f7.pusher = new Pusher('84d7991410678a0998f6', {
					cluster: 'ap1',
					forceTLS: true
				});

				const panic_channel = f7.pusher.subscribe('panic');				
				let current_reporter = null;
				let realMediaStop = false;

				//listen panic alarm 
				panic_channel.bind('alarm', function(data) {
					if(data && data.ids.length > 0 && current_reporter != data.reporter.id){
						if(data.ids.indexOf(self.user.id) > -1){
							
							let realMediaStop = false;
							const media = new Media('/android_asset/www/static/alarm-buzzer.mp3', null, function(e){
								console.log('Media Error: ', e);
							}, function(status){
								if(status === Media.MEDIA_STOPPED) {
									if(realMediaStop == false){
										media.seekTo(0);
										media.play();
									}else{
										media.stop();
										media.release();
									}
								} 
							});
							media.play({numberOfLoops:9999});

							self.panic = {
								id: data.panic.id,
								title: data.panic.name.toUpperCase(),
								reporter: data.reporter.fullname.toUpperCase(),
								address: data.reporter.address,
								phone: data.reporter.phone,
								latitude: parseFloat(data.reporter.latitude),
								longitude: parseFloat(data.reporter.longitude)
							};

							self.map.center = {
								lat: parseFloat(data.reporter.latitude),
								lng: parseFloat(data.reporter.longitude),
							}

							//trigger sheet modal
							if(!self.sheet){
								self.sheet = f7.sheet.create({
									el: '.panic-swipe-to-step',
									swipeToClose: false,
									swipeToStep: true,
									backdrop: true,
									closeByBackdropClick: false,
									on: {
										closed: function(sheet){
											realMediaStop = true;
											media.stop();
											media.release();
										}
									}
								});								
							}

							if (f7.$('.panic-swipe-to-step.modal-in').length > 0) f7.sheet.close('.panic-swipe-to-step');
							
							self.sheet.open();

							f7.$('#panic-close').on('click', function(){
								realMediaStop = true;
								media.stop();	
								media.release();				
								self.sheet.close();
							});

							f7.$('#sound-off').once('click', function(){
								realMediaStop = true;
								media.stop();	
								media.release();				
							});

							current_reporter = data.reporter.id;

						}
					}					
				});

				//listen livelocation
				panic_channel.bind('livelocation', function(data) {
					if(data && data.ids.length > 0 && data.ids.indexOf(self.user.id) > -1){
						self.map.center = {
							lat: parseFloat(data.latitude),
							lng: parseFloat(data.longitude)
						}
					}

				});

				self.$$('#view-home').on('tab:show', function(){
					f7.views.main.router.navigate('/');
				});

				self.$$('#view-chat').on('tab:show', function(){
					f7.views.chat.router.navigate('/chat/');
				});

				self.$$('#view-panic').on('tab:show', function(){
					f7.views.panic.router.navigate('/panic/');
				});

				self.$$('#view-marketplace').on('tab:show', function(){
					f7.views.marketplace.router.navigate('/marketplace/');
				});

				self.$$('#view-account').on('tab:show', function(){
					f7.views.account.router.navigate('/account/');
				});

			});
		}
	}
</script>

<style>
	#panic-map{
		height: 450px;
		width: 100%;
	}
</style>
